diff -ur libdvbpsi-1.1.0_orig/src/tables/atsc_eit.c libdvbpsi-1.1.0/src/tables/atsc_eit.c
--- libdvbpsi-1.1.0_orig/src/tables/atsc_eit.c	2012-11-14 10:03:45.000000000 -0500
+++ libdvbpsi-1.1.0/src/tables/atsc_eit.c	2013-10-03 09:22:58.102419212 -0400
@@ -360,7 +360,7 @@
                                                 p_section->p_payload_start[0],
                                                 p_section->i_extension,
                                                 p_section->b_current_next);
-        if (p_decoder->p_building_eit)
+        if (!p_decoder->p_building_eit)
             return false;
 
         p_decoder->i_last_section_number = p_section->i_last_number;
diff -ur libdvbpsi-1.1.0_orig/src/tables/atsc_ett.c libdvbpsi-1.1.0/src/tables/atsc_ett.c
--- libdvbpsi-1.1.0_orig/src/tables/atsc_ett.c	2012-11-14 10:03:45.000000000 -0500
+++ libdvbpsi-1.1.0/src/tables/atsc_ett.c	2013-10-03 11:40:02.796080274 -0400
@@ -297,7 +297,7 @@
                                                        p_section->p_payload_start[0],
                                                        i_etm_id,
                                                        p_section->b_current_next);
-        if (p_decoder->p_building_ett)
+        if (!p_decoder->p_building_ett)
             return false;
 
         p_decoder->i_last_section_number = p_section->i_last_number;
diff -ur libdvbpsi-1.1.0_orig/src/tables/atsc_mgt.c libdvbpsi-1.1.0/src/tables/atsc_mgt.c
--- libdvbpsi-1.1.0_orig/src/tables/atsc_mgt.c	2012-11-14 10:03:45.000000000 -0500
+++ libdvbpsi-1.1.0/src/tables/atsc_mgt.c	2013-09-27 09:11:44.625228504 -0400
@@ -384,7 +384,7 @@
                                                        p_section->i_version,
                                                        p_section->p_payload_start[0],
                                                        p_section->b_current_next);
-        if (p_decoder->p_building_mgt)
+        if (!p_decoder->p_building_mgt)
             return false;
 
         p_decoder->i_last_section_number = p_section->i_last_number;
@@ -502,13 +502,17 @@
         /* Delete the sections */
         dvbpsi_DeletePSISections(p_mgt_decoder->p_sections);
         p_mgt_decoder->p_sections = NULL;
+        p_section = NULL;
         /* signal the new MGT */
         p_mgt_decoder->pf_mgt_callback(p_mgt_decoder->p_cb_data,
                                        p_mgt_decoder->p_building_mgt);
         /* Reinitialize the structures */
         dvbpsi_ReInitMGT(p_mgt_decoder, false);
     }
-    dvbpsi_DeletePSISections(p_section);
+    if( NULL != p_section )
+    {
+        dvbpsi_DeletePSISections(p_section);
+    }
 }
 
 /*****************************************************************************
diff -ur libdvbpsi-1.1.0_orig/src/tables/atsc_stt.c libdvbpsi-1.1.0/src/tables/atsc_stt.c
--- libdvbpsi-1.1.0_orig/src/tables/atsc_stt.c	2012-11-14 10:03:45.000000000 -0500
+++ libdvbpsi-1.1.0/src/tables/atsc_stt.c	2013-10-03 09:27:50.652313420 -0400
@@ -288,7 +288,7 @@
     {
         p_decoder->p_building_stt = dvbpsi_atsc_NewSTT(p_section->i_table_id, p_section->i_extension,
                                                        p_section->i_version, p_section->b_current_next);
-        if (p_decoder->p_building_stt)
+        if (!p_decoder->p_building_stt)
             return false;
 
         p_decoder->i_last_section_number = p_section->i_last_number;
diff -ur libdvbpsi-1.1.0_orig/src/tables/atsc_vct.c libdvbpsi-1.1.0/src/tables/atsc_vct.c
--- libdvbpsi-1.1.0_orig/src/tables/atsc_vct.c	2012-11-26 04:14:18.000000000 -0500
+++ libdvbpsi-1.1.0/src/tables/atsc_vct.c	2013-10-03 09:29:26.546689575 -0400
@@ -423,7 +423,7 @@
                               p_section->i_table_id, p_section->i_extension,
                               p_section->p_payload_start[0], p_section->i_table_id == 0xC9,
                               p_section->i_version, p_section->b_current_next);
-        if (p_vct_decoder->p_building_vct)
+        if (!p_vct_decoder->p_building_vct)
             return false;
 
         p_vct_decoder->i_last_section_number = p_section->i_last_number;
